# Render next frame of a breakout game using only regular expressions
#
# Copyright (C) 2018 Mike Gerwitz
#
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
# This is a work in progress.  See commit message(s).
##

# Accumulate all text (including newlines) into pattern space so that
# regular expressions can span lines.
:a; N; $!ba

# Always end in a newline.
s/[^\n]$/&\n/


# From bottom
s/^\( -.*\)\[==\]\(.\{77,80\}\)o /\1[##]\2x /
s/^\(--.*\)\[==\]\(.\{78,81\}\)o/\1[##]\2x/
s/^\(- .*\)\[==\]\(.\{78,81\}\) o/\1[##]\2 x/

s/^\( -.*\)\[##\]\(.\{77,80\}\)o /\1    \2x /
s/^\(--.*\)\[##\]\(.\{78,81\}\)o/\1    \2x/
s/^\(- .*\)\[##\]\(.\{78,81\}\) o/\1    \2 x/

# From top
s/^\(_ .*\) o\(.\{77,80\}\)\[==\]/\1 x\2[##]/
s/^\(__.*\)o\(.\{78,81\}\)\[==\]/\1x\2[##]/
s/^\( _.*\)o \(.\{78,81\}\)\[==\]/\1x \2[##]/

s/^\(_ .*\) o\(.\{77,80\}\)\[##\]/\1 x\2    /
s/^\(__.*\)o\(.\{78,81\}\)\[##\]/\1x\2    /
s/^\( _.*\)o \(.\{78,81\}\)\[##\]/\1x \2    /

# From left/right
s/^\( [_-].*\)o\[==\]/\1X[##]/
s/^\([_-] *\)\[==\]o/\1[##]X/

s/^\( [_-].*\)o\[##\]/\1X    /
s/^\([_-] .*\)\[##\]o/\1    X/


# Paddle sides from top (must do before ceiling/floor)
s/^__\(.*\)o\(.\{81\}<\)/_ \1x\2/
s/^ _\(.*\)o\(.\{82\}<\)/__\1x\2/

s/^_ \(.*\)o\(.\{80\}>\)/__\1x\2/
s/^__\(.*\)o\(.\{81\}>\)/ _\1x\2/


# Ceiling, floor, or middle of paddle
s/^\(.\?-.*[^ ].\{81\}\)o/\1x/
s/^\(.\?_.*\)o\(.\{81\}[^ ]\)/\1x\2/


# Hit wall
s/^\(.[_-].*\)o|/\1X|/
s/^\([_-].*\)|o/\1|X/


# Reflect vertical
s/^__\(.*\)x/--\1o/
s/^_ \(.*\)x/- \1o/
s/^ _\(.*\)x/ -\1o/

s/^_-\(.*\)x/+_\1o/
s/^-_\(.*\)x/_+\1o/

s/^--\(.*\)x/__\1o/
s/^- \(.*\)x/_ \1o/
s/^ -\(.*\)x/ _\1o/

s/^-+\(.*\)x/_+\1o/
s/^+-\(.*\)x/+_\1o/

# Reflect horizontal
s/^\(.\)\([_-]\)\(.*\)X/\2\1\3o/
s/^\([_-]\)\(.\)\(.*\)X/\2\1\3o/


# Move
s/^\(_ .*\)o\(.\{80\}\) /\1 \2o/
s/^\(__.*\)o\(.\{81\}\) /\1 \2o/
s/^\( _.*\)o\(.\{82\}\) /\1 \2o/

s/^\(_+.*\)o\(.\{78\}\) /\1 \2o/
s/^\(+_.*\)o\(.\{84\}\) /\1 \2o/

s/^\(- .*\) \(.\{82\}\)o/\1o\2 /
s/^\(--.*\) \(.\{81\}\)o/\1o\2 /
s/^\( -.*\) \(.\{80\}\)o/\1o\2 /

s/^\(-+.*\) \(.\{84\}\)o/\1o\2 /
s/^\(+-.*\) \(.\{78\}\)o/\1o\2 /
